package com.sun.xml.internal.ws.server.sei;

import javax.xml.ws.Holder;
import com.sun.xml.internal.ws.model.ParameterImpl;

public abstract class EndpointValueSetter
{
    private static final EndpointValueSetter[] POOL;
    
    private EndpointValueSetter() {
    }
    
    abstract void put(Object p0, Object[] p1);
    
    public static EndpointValueSetter get(ParameterImpl p) {
        int idx = p.getIndex();
        if (p.isIN()) {
            if (idx < EndpointValueSetter.POOL.length) {
                return EndpointValueSetter.POOL[idx];
            }
            return new Param(idx);
        }
        else {
            return new HolderParam(idx);
        }
    }
    
    EndpointValueSetter(EndpointValueSetter.1 x0) {
        this();
    }
    
    static {
        POOL = new EndpointValueSetter[16];
        for (int i = 0; i < EndpointValueSetter.POOL.length; ++i) {
            EndpointValueSetter.POOL[i] = new Param(i);
        }
    }
    
    static class Param extends EndpointValueSetter
    {
        protected final int idx;
        
        public Param(int idx) {
            super(null);
            this.idx = idx;
        }
        
        @Override
        void put(Object obj, Object[] args) {
            if (obj != null) {
                args[this.idx] = obj;
            }
        }
    }
    
    static final class HolderParam extends EndpointValueSetter.Param
    {
        public HolderParam(int idx) {
            super(idx);
        }
        
        @Override
        void put(Object obj, Object[] args) {
            Holder holder = new Holder();
            if (obj != null) {
                holder.value = obj;
            }
            args[this.idx] = holder;
        }
    }
}
